/**
 * Copyright (c) 2015, STARSCHEMA LTD.
 * All rights reserved.

 * Redistribution and use in source and binary forms, with or without modification, are permitted
 * provided that the following conditions are met:

 * 1. Redistributions of source code must retain the above copyright notice, this
 * list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 * this list of conditions and the following disclaimer in the documentation
 * and/or other materials provided with the distribution.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * Modified by
 * @author  Data Virtuality GmbH
 * @date    $Date$
 */
package net.starschema.clouddb.jdbc.list;

import net.starschema.clouddb.jdbc.JdbcGrammarParser;


/**
 * This class extends the basic Node
 * we store a simple string in it
 *
 * @author Balazs Gunics, Attila Horvath
 */
public class StringLiteral extends Node {
	// EXTENSION
	// ISSUE: DVCORE-2780
	// FIXED BY: Roman Pedchenko
	// DATE: 2015.04.09
	private boolean skipQuotes = false;
	// END EXTENSION
    /**
     * to Store the Stringliterals
     *
     * @param string
     *            - this will be stored at the data field
     */
	// EXTENSION
	// ISSUE: DVCORE-2293
	// FIXED BY: Roman Pedchenko
	// DATE: 2014.10.13
//    public StringLiteral(String string) {
//        this.tokenType = JdbcGrammarParser.STRINGLIT;
    public StringLiteral(String string, int tokenType) {
        this.tokenType = tokenType;
	// END EXTENSION
        this.tokenName = JdbcGrammarParser.tokenNames[this.tokenType];
        this.logger.debug("BUILDING " + this.tokenName);
        this.data = string;
    }
    
    // EXTENSION
    // ISSUE: DVCORE-2780
    // FIXED BY: Roman Pedchenko
    // DATE: 2015.04.09
    public StringLiteral(String string, boolean skipQuotes) {
    	this(string, JdbcGrammarParser.STRINGLIT);
    	this.skipQuotes = skipQuotes;
    }
    // END EXTENSION

    @Override
    public String toPrettyString(int level) {
        //since we store the Ints as String, we'll try to parse them to Int, 
		// EXTENSION
		// ISSUE: DVCORE-2293
		// FIXED BY: Roman Pedchenko
		// DATE: 2014.10.13
//        try{
//            Integer.parseInt(this.data);
//        }
//        catch (NumberFormatException nfe){
//            return "'" + this.data + "'";
//        }
//        return this.data;
    	// EXTENSION
    	// ISSUE: DVCORE-2780
    	// FIXED BY: Roman Pedchenko
    	// DATE: 2015.04.09
    	// if (tokenType == JdbcGrammarParser.INTEGERPARAM || tokenType == JdbcGrammarParser.FLOATPARAM)
    	if (skipQuotes || tokenType == JdbcGrammarParser.INTEGERPARAM || tokenType == JdbcGrammarParser.FLOATPARAM)
    	// END EXTENSION
    		return this.data;
    	else
    		return "'" + this.data + "'";
		// END EXTENSION
    }
}
